OFB_ModePolicy Class Reference

OFB block cipher mode of operation. More...

Inheritance diagram for OFB_ModePolicy:

## Public Member Functions

bool | CipherIsRandomAccess () const
| Flag indicating random access. More...
IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs. More...
Public Member Functions inherited from CipherModeBase
size_t | MinKeyLength () const
| Returns smallest valid key length in bytes.
size_t | MaxKeyLength () const
| Returns largest valid key length in bytes.
size_t | DefaultKeyLength () const
| Returns default (recommended) key length in bytes.
size_t | GetValidKeyLength (size_t n) const
bool | IsValidKeyLength (size_t n) const
| Returns whether keylength is a valid key length. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
void | SetCipher (BlockCipher &cipher)
void | SetCipherWithIV (BlockCipher &cipher, const byte *iv, int feedbackSize=0)
Public Member Functions inherited from SimpleKeyingInterface
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs returns whether the object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV), false otherwise.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual void | ProcessData (byte *outString, const byte *inString, size_t length)=0
| Encrypt or decrypt an array of bytes. More...
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual bool | IsRandomAccess () const =0
| Determines whether the cipher supports random access. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...
virtual bool | IsSelfInverting () const =0
| Determines whether the cipher is self-inverting. More...
virtual bool | IsForwardTransformation () const =0
| Determines if the cipher is being operated in its forward direction. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from AdditiveCipherAbstractPolicy
virtual unsigned int | GetOptimalBlockSize () const
| Provides number of ideal bytes to process. More...
virtual bool | CanOperateKeystream () const
| Flag indicating. More...
virtual void | OperateKeystream (KeystreamOperation operation, byte *output, const byte *input, size_t iterationCount)
| Operates the keystream. More...
virtual void | SeekToIteration (lword iterationCount)
| Seeks to a random position in the stream. More...

## Static Public Member Functions

static const char * | StaticAlgorithmName ()

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

OFB block cipher mode of operation.

Definition at line 141 of file modes.h.

## Member Function Documentation

## CipherIsRandomAccess()

bool OFB_ModePolicy::CipherIsRandomAccess | ( |  | ) | const

inline virtual

Flag indicating random access.

Returns
  true if the cipher is seekable, false otherwise

See also
  SeekToIteration()

Implements AdditiveCipherAbstractPolicy.

Definition at line 144 of file modes.h.

## IVRequirement()

IV_Requirement OFB_ModePolicy::IVRequirement | ( |  | ) | const

inline virtual

Minimal requirement for secure IVs.

Returns
  the secure IV requirement of the algorithm

Implements CipherModeBase.

Definition at line 145 of file modes.h.

The documentation for this class was generated from the following files:

- modes.h
- modes.cpp